<template>
  <a class="record" :class="classes" :href="link">
    <div v-if="loading">
      <div class="record-header">
        <span class="header-field reservation-date"
          ><span class="placeholder lp"></span
        ></span>
        <span class="header-field reservation-state"
          ><span class="placeholder lp"></span
        ></span>
      </div>

      <div class="record-body">
        <div class="restaurant-photo lp"></div>

        <div class="restaurant-info">
          <span class="info-field restaurant-name"
            ><span class="placeholder lp"></span
          ></span>
          <span class="info-field restaurant-address"
            ><span class="placeholder lp"></span
          ></span>
          <span class="info-field restaurant-note"
            ><span class="placeholder lp"></span
          ></span>
        </div>

        <div class="reservation-info">
          <span class="reservation-group-size"
            ><span class="placeholder lp"></span
          ></span>
        </div>
      </div>
    </div>

    <div v-else>
      <div class="record-header">
        <span class="header-field reservation-date">{{ datetime }}</span>
        <span class="header-field reservation-state">{{
          reservation.stateLabel
        }}</span>
      </div>

      <div class="record-body">
        <div
          class="restaurant-photo"
          :style="reservation.companyLogoStyle"
        ></div>

        <div class="restaurant-info">
          <span class="info-field restaurant-name">{{
            reservation.companyName
          }}</span>
          <span class="info-field restaurant-address">{{
            reservation.branchAddress
          }}</span>
          <span class="info-field restaurant-note">{{
            reservation.customerNote
          }}</span>
        </div>

        <div class="reservation-info">
          <span class="reservation-group-size">{{
            $t("records.groupSize", reservation)
          }}</span>
          <!--<span class="reservation-tags"></span>-->
        </div>
      </div>

      <!--
      <div class="record-footer">
        <a class="button restaurant-button" :href="reservation.branchLink">{{ $t('records.restaurantButton') }}</a>
        <a class="button reservation-button" :href="reservation.reservationLink">{{ $t('records.reservationButton') }}</a>
      </div>
      -->
    </div>
  </a>
</template>

<script>
import { mapGetters } from "vuex";

export default {
  props: {
    reservation: {
      type: Object,
      required: false
    }
  },

  computed: {
    ...mapGetters("theme", ["themeClasses"]),

    loading() {
      return !this.reservation;
    },

    datetime() {
      return this.reservation.isWaiting && this.reservation.state === "waiting"
        ? this.reservation.displayTime.fromNow()
        : this.reservation.displayTime.format("M/D ddd HH:mm");
    },

    classes() {
      var classes = { ...this.themeClasses };
      if (!this.loading) {
        classes = {
          ...classes,
          canclled: this.reservation.state === "cancelled"
        };
      } else {
        classes.loading = true;
      }
      return classes;
    },

    link() {
      return this.reservation && this.reservation.reservationLink;
    }
  }
};
</script>

<style lang="scss" scoped>
.record {
  display: block;
  background: $color-white;
  border: 1px $color-sky-grey solid;
  border-radius: 5px;
  cursor: pointer;
  color: inherit;

  &.theme-vip-member {
    border-color: $color-skm-gold;
  }

  &.canclled {
    opacity: 0.5;
  }
}

.record-header {
  line-height: 2.8em;
  font-size: 14px;
  margin: 0 15px;
  border-bottom: 1px $color-sky-grey solid;
  display: flex;

  .header-field {
    flex-grow: 1;
  }
}

.reservation-state {
  text-align: right;
  color: $color-primary-grey;
}

.record-body {
  display: flex;
  margin: 15px;
}

.restaurant-info {
  flex-grow: 1;
  width: 50%;
  box-sizing: border-box;
  padding: 0 15px;
  font-size: 12px;

  .info-field {
    display: block;
  }
}

.restaurant-photo {
  width: 64px;
  height: 64px;
  background-size: contain;
  background-repeat: no-repeat;
  background-position: center center;
  border-radius: 3px;
  border: 12px transparent solid;
  box-sizing: border-box;
}

.reservation-info {
  width: 30%;
  text-align: right;
}

.restaurant-name {
  font-size: 16px;
  font-weight: bold;
}

.restaurant-note {
  color: $color-primary-grey;
}

.reservation-group-size {
  font-size: 16px;
}

.record-footer {
  border-top: 1px $color-sky-grey solid;
  line-height: 49px;
  display: flex;

  .button {
    flex-grow: 1;
    text-align: center;
    background: none;
    border: none;
    border-right: 1px $color-sky-grey solid;
    font-size: 16px;

    &:last-child {
      border: none;
    }
  }
}

.theme-vip-member {
  .button {
    color: $color-gold-300;
  }
}

.loading {
  .placeholder {
    display: inline-block;
    height: 1em;
  }

  .reservation-date .placeholder {
    width: 100px;
  }

  .reservation-state .placeholder {
    width: 38px;
  }

  .restaurant-name .placeholder {
    width: 38px;
  }

  .restaurant-address .placeholder {
    width: 120px;
  }

  .restaurant-note .placeholder {
    width: 38px;
  }

  .reservation-group-size .placeholder {
    width: 80px;
  }
}
</style>
